diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index b6820a41..9e3ca346 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -19,6 +19,8 @@ module Hive
     SENTINEL_POLL_INTERVAL_SEC = 5
     SENTINEL_CAPTURE_BYTES = 8192
     PANE_LOG_CAPTURE_BYTES = 64 * 1024
+    FALLBACK_EXIT_POLL_INTERVAL_SEC = 0.1
+    FALLBACK_EXIT_GRACE_SEC = 5.0
     # Shared-session reviewer sends re-call `prepare_claude_session!`
     # between each per-reviewer prompt; a 30s ceiling was too tight for
     # the legitimate case where the prior reviewer's response was still
@@ -128,7 +130,8 @@ module Hive
 
     SessionHandle = Struct.new(:task, :runner, :reestablish, keyword_init: true) do
       def send_and_wait!(prompt:, expected_output: nil, timeout_sec:,
-                         status_mode: nil, log_label: nil, deadline: nil)
+                         status_mode: nil, log_label: nil, deadline: nil,
+                         completion_verifier: nil)
         Hive::ClaudeLauncher.send_prompt_and_wait!(
           task: task,
           runner: runner,
@@ -138,7 +141,8 @@ module Hive
           status_mode: status_mode,
           log_label: log_label,
           deadline: deadline,
-          reestablish: reestablish
+          reestablish: reestablish,
+          completion_verifier: completion_verifier
         )
       end
     end
@@ -151,7 +155,7 @@ module Hive
                 allowed_tools: nil,
                 disallowed_tools: nil,
                 permission_mode: nil, mcp_config_path: nil,
-                strict_mcp_config: false)
+                strict_mcp_config: false, completion_verifier: nil)
       profile ||= Hive::AgentProfiles.lookup(:claude, cfg: cfg)
       ensure_claude_profile!(profile)
       permission_mode ||= Hive::Config.claude_permission_mode(cfg)
@@ -202,7 +206,8 @@ module Hive
           expected_output: expected_output,
           timeout_sec: timeout_sec,
           status_mode: status_mode || profile.status_detection_mode,
-          log_label: log_label
+          log_label: log_label,
+          completion_verifier: completion_verifier
         )
       end
       result
@@ -281,7 +286,8 @@ module Hive
 
     def send_prompt_and_wait!(task:, runner:, prompt:, timeout_sec:,
                               expected_output: nil, status_mode: nil,
-                              log_label: nil, deadline: nil, reestablish: nil)
+                              log_label: nil, deadline: nil, reestablish: nil,
+                              completion_verifier: nil)
       reset_signal_files(task)
       cleanup_expected_output(expected_output)
       reestablish_dead_session!(runner, reestablish)
@@ -305,7 +311,10 @@ module Hive
                           started: Time.now.utc.iso8601)
       end
       runner.send_prompt(prompt)
-      result = wait_for_status(task, runner, effective_timeout_sec, status_mode, expected_output, log_label)
+      result = wait_for_status(
+        task, runner, effective_timeout_sec, status_mode, expected_output, log_label,
+        completion_verifier: completion_verifier
+      )
       # Headless launches drop a `<log_label>-<ts>.log` under
       # `task.log_dir`; tmux launches need the same shared log path so
       # downstream Claude-driven stages can find per-invocation output.
@@ -364,15 +373,28 @@ module Hive
       nil
     end
 
-    def wait_for_status(task, runner, timeout, status_mode, expected_output, log_label)
+    def wait_for_status(task, runner, timeout, status_mode, expected_output, log_label,
+                        completion_verifier: nil)
       case status_mode || :state_file_marker
       when :state_file_marker
-        marker = wait_for_terminal_marker(task, runner, timeout)
-        { status: marker.name, log_label: log_label }
+        result = wait_for_terminal_marker(
+          task, runner, timeout, completion_verifier: completion_verifier,
+          expected_output: expected_output || (task.respond_to?(:state_file) ? task.state_file : nil),
+          log_label: log_label
+        )
+        return result if result.is_a?(Hash)
+
+        { status: result.name, log_label: log_label }
       when :output_file_exists
-        wait_for_expected_output(task, runner, timeout, expected_output, log_label)
+        wait_for_expected_output(
+          task, runner, timeout, expected_output, log_label,
+          completion_verifier: completion_verifier
+        )
       when :exit_code_only
-        wait_for_done_signal(task, runner, timeout, log_label)
+        wait_for_done_signal(
+          task, runner, timeout, log_label, expected_output: expected_output,
+          completion_verifier: completion_verifier
+        )
       else
         raise ArgumentError, "unknown status_mode: #{status_mode.inspect}"
       end
@@ -552,8 +574,21 @@ module Hive
     # single-shot path (`reestablish` nil), preserving the hard-fail there.
     def reestablish_dead_session!(runner, reestablish)
       return unless reestablish
-      return unless runner.respond_to?(:session_exists?) && !runner.session_exists?
+      return unless runner.respond_to?(:session_exists?)
+
+      if !runner.session_exists?
+        reestablish.call
+        return
+      end
+
+      # Managed panes use remain-on-exit so a fallback can read the real
+      # process status.  A retained dead pane is still a live tmux session,
+      # but cannot accept the next reviewer prompt; tear it down before
+      # re-establishing the shared Claude session.
+      return unless runner.respond_to?(:pane_state)
+      return unless runner.pane_state.dead?
 
+      runner.kill_session if runner.respond_to?(:kill_session)
       reestablish.call
     end
 
@@ -669,7 +704,8 @@ module Hive
       current_lines.reject(&:empty?).last(CLAUDE_PROMPT_CONTEXT_LINES).join("\n")
     end
 
-    def wait_for_terminal_marker(task, runner, timeout)
+    def wait_for_terminal_marker(task, runner, timeout, completion_verifier: nil,
+                                 expected_output: nil, log_label: nil)
       deadline = Time.now + timeout
       last_sentinel_check = Time.at(0)
       loop do
@@ -704,6 +740,32 @@ module Hive
             return existing
           end
 
+          # R2: every status mode, including the default marker mode, may use
+          # the shared missing-signal fallback when a verifier is provided.
+          mode_output = expected_output || task.state_file
+          fallback = missing_signal_fallback(
+            task, runner,
+            status_mode: :state_file_marker,
+            expected_output: mode_output,
+            missing_signal_reason: "claude stop hook did not signal completion",
+            log_label: log_label,
+            completion_verifier: completion_verifier
+          )
+          if fallback.is_a?(Hash)
+            case fallback[:status]
+            when :fallback_candidate, :error
+              return fallback
+            when :ok
+              marker = Hive::Markers.current(task.state_file)
+              return marker if terminal_marker?(marker)
+
+              return fallback
+            else
+              # Non-ok primary hook status (e.g. failed/cancelled via result.json).
+              return fallback if fallback[:completion_source] == :primary
+            end
+          end
+
           Hive::Markers.set(task.state_file, :error, reason: "timeout", timeout_sec: timeout)
           return Hive::Markers.current(task.state_file)
         end
@@ -763,7 +825,8 @@ module Hive
       nil
     end
 
-    def wait_for_expected_output(task, runner, timeout, expected_output, log_label)
+    def wait_for_expected_output(task, runner, timeout, expected_output, log_label,
+                                 completion_verifier: nil)
       deadline = Time.now + timeout
       tmux_error_streak = 0
       last_tmux_error_msg = nil
@@ -811,6 +874,16 @@ module Hive
         end
 
         if Time.now >= deadline
+          fallback = missing_signal_fallback(
+            task, runner,
+            status_mode: :output_file_exists,
+            expected_output: expected_output,
+            missing_signal_reason: "expected output exists but Claude Stop hook did not signal completion",
+            log_label: log_label,
+            completion_verifier: completion_verifier
+          )
+          return fallback if fallback
+
           return {
             status: :timeout,
             error_message: "expected output file missing or empty: #{expected_output}"
@@ -841,7 +914,8 @@ module Hive
       ""
     end
 
-    def wait_for_done_signal(task, runner, timeout, log_label)
+    def wait_for_done_signal(task, runner, timeout, log_label, expected_output: nil,
+                             completion_verifier: nil)
       deadline = Time.now + timeout
       loop do
         # A usage/credit wall stalls claude WITHOUT ever touching `.done`,
@@ -883,6 +957,16 @@ module Hive
         end
 
         if Time.now >= deadline
+          fallback = missing_signal_fallback(
+            task, runner,
+            status_mode: :exit_code_only,
+            expected_output: expected_output,
+            missing_signal_reason: "claude stop hook did not signal completion",
+            log_label: log_label,
+            completion_verifier: completion_verifier
+          )
+          return fallback if fallback
+
           return { status: :timeout, error_message: "claude stop hook did not signal completion" }
         end
 
@@ -890,6 +974,134 @@ module Hive
       end
     end
 
+    # The Stop hook remains the primary completion signal.  This deliberately
+    # narrow escape hatch is used only after the ordinary wait exhausted its
+    # budget *and* a mode-specific artifact exists.  A ready/idle prompt is
+    # merely permission to ask a completed Claude turn to quit; it is never
+    # evidence of a clean result.  We require tmux to retain a dead pane with
+    # an explicit zero exit status before returning a fallback candidate.
+    #
+    # Callers must provide a verifier.  Returning :defer lets a stage perform
+    # its own post-exit checks (for example, scope-checked auto-commit) before
+    # accepting the candidate.  Without that explicit contract, every mode
+    # keeps its historical strict timeout behavior.
+    def missing_signal_fallback(task, runner, status_mode:, expected_output:,
+                                missing_signal_reason:, log_label:,
+                                completion_verifier:)
+      return nil unless completion_verifier
+      return nil unless expected_output_available?(expected_output)
+      return nil unless runner && runner.respond_to?(:pane_state) && runner.respond_to?(:send_prompt)
+
+      pane = runner.capture_pane_tail(bytes: SENTINEL_CAPTURE_BYTES)
+      return nil unless claude_ready_prompt?(pane)
+
+      # A provider-limit menu has stronger semantics than a missing signal and
+      # must win even when an expected output artifact happens to exist.
+      if (limit_line = Hive::AgentLimit.live_limit_line(pane))
+        return {
+          status: :error,
+          limit_text: limit_line,
+          error_message: Hive::AgentLimit.error_message(limit_line, agent: "claude")
+        }
+      end
+
+      # A partial Stop-hook publish of result.json (non-ok, no .done yet)
+      # keeps error precedence over the zero-exit fallback candidate.
+      hook_error = primary_hook_error_result(task, log_label)
+      return hook_error if hook_error
+
+      runner.send_prompt("/quit")
+      deadline = Time.now + fallback_exit_grace_sec
+      state = nil
+      loop do
+        # Late primary signal must re-enter the normal result-json path,
+        # never collapse into a hard timeout via a bare nil return.
+        if File.exist?(done_path(task))
+          return primary_signal_result(task, log_label)
+        end
+
+        state = runner.pane_state
+        break if state.dead? || Time.now >= deadline
+
+        sleep [ FALLBACK_EXIT_POLL_INTERVAL_SEC, deadline - Time.now ].min
+      end
+      return nil unless state&.dead? && state.exit_status == 0
+      return nil unless expected_output_available?(expected_output)
+
+      # Re-check after graceful quit: a late non-ok result.json still wins.
+      hook_error = primary_hook_error_result(task, log_label)
+      return hook_error if hook_error
+
+      observation = completion_observation(
+        task, runner,
+        status_mode: status_mode,
+        expected_output: expected_output,
+        missing_signal_reason: missing_signal_reason,
+        pane_state: state
+      )
+      verdict = completion_verifier.call(observation)
+      case verdict
+      when :defer
+        { status: :fallback_candidate, log_label: log_label,
+          completion_source: :fallback, completion_observation: observation }
+      when true
+        { status: :ok, log_label: log_label,
+          completion_source: :fallback, completion_observation: observation }
+      else
+        nil
+      end
+    rescue Hive::TmuxError => e
+      {
+        status: :error,
+        error_message: "tmux_pane_unreadable: #{e.message}"
+      }
+    end
+
+    # Process a late-arriving `.done` the same way the primary waiters do so
+    # the fallback path cannot lose a valid Stop-hook completion to timeout.
+    def primary_signal_result(task, log_label)
+      status = read_result_json_status(task)
+      if status == :ok
+        { status: :ok, log_label: log_label, completion_source: :primary }
+      elsif status
+        { status: status, log_label: log_label,
+          error_message: "claude reported #{status.inspect} via result.json",
+          completion_source: :primary }
+      else
+        # Historical exit_code_only contract: .done without result.json is ok.
+        { status: :ok, log_label: log_label, completion_source: :primary }
+      end
+    end
+
+    # When result.json is present with a non-ok status, the Stop hook already
+    # reported failure. Fallback must not suppress that with a zero-exit win.
+    def primary_hook_error_result(task, log_label)
+      status = read_result_json_status(task)
+      return nil if status.nil? || status == :ok
+
+      { status: status, log_label: log_label,
+        error_message: "claude reported #{status.inspect} via result.json",
+        completion_source: :primary }
+    end
+
+    def completion_observation(task, runner, status_mode:, expected_output:,
+                               missing_signal_reason:, pane_state:)
+      {
+        status_mode: status_mode,
+        completion_source: :fallback,
+        pid: pane_state.pid || (runner.pane_pid if runner.respond_to?(:pane_pid)),
+        session: (runner.name if runner.respond_to?(:name)),
+        expected_sentinel_path: done_path(task),
+        result_path: result_path(task),
+        expected_output: expected_output,
+        expected_outputs_observed: [ expected_output ],
+        missing_signal_reason: missing_signal_reason,
+        tmux_health: :readable,
+        process_exit_code: pane_state.exit_status,
+        wrapper_completion_recorded: false
+      }
+    end
+
     # Read `result.json` (if present) and translate `status` into the
     # caller's symbol vocabulary. Unknown / unparseable shapes return
     # nil so the caller can fall through to its default success path.
@@ -1127,5 +1339,9 @@ module Hive
     def claude_shutdown_grace
       Float(tmux_env("SHUTDOWN_GRACE_SEC", "0.5"))
     end
+
+    def fallback_exit_grace_sec
+      Float(tmux_env("FALLBACK_EXIT_GRACE_SEC", FALLBACK_EXIT_GRACE_SEC.to_s))
+    end
   end
 end
diff --git a/lib/hive/daemon/stale_agent_healer.rb b/lib/hive/daemon/stale_agent_healer.rb
index 02042f78..f48f61f9 100644
--- a/lib/hive/daemon/stale_agent_healer.rb
+++ b/lib/hive/daemon/stale_agent_healer.rb
@@ -1,9 +1,14 @@
 require "digest"
+require "json"
 require "open3"
 require "time"
 require "yaml"
 require "hive/lock"
 require "hive/markers"
+require "hive/stages/review/completion_evidence"
+require "hive/stages/review/context"
+require "hive/stages/review/orchestrator_owned"
+require "hive/worktree"
 require "hive/workflows"
 require "hive/daemon/dispatch_request_queue"
 
@@ -427,7 +432,23 @@ module Hive
 
       def heal_review_error_if_auto_recoverable(row, now:)
         return if row.live_task_lock == true
-        return unless auto_recoverable_review_error?(row, now: now)
+        legacy_evidence = nil
+        if fix_claude_stop_hook_failure?(marker_attrs_for(row))
+          legacy_evidence, refusal = retained_fix_completion_evidence(row)
+          unless legacy_evidence
+            @logger.event(:marker_heal_refused,
+                          project: row.project,
+                          slug: row.slug,
+                          stage: row.stage,
+                          prior_marker: row.marker,
+                          reason: "fix_claude_stop_hook_evidence_missing",
+                          marker_reason: marker_reason(row),
+                          refusal: refusal,
+                          remediation: review_error_recovery_remediation(row, marker_reason(row)))
+            return
+          end
+        end
+        return unless auto_recoverable_review_error?(row, now: now, retained_completion_evidence: legacy_evidence)
 
         reason = marker_reason(row)
         marker_attrs = review_marker_attrs(row)
@@ -472,6 +493,7 @@ module Hive
                       phase: marker_attrs["phase"],
                       pass: marker_attrs["pass"],
                       errors_path: reviewer_errors_path(row),
+                      recovered_evidence: legacy_evidence && legacy_evidence.artifacts_checked,
                       attempts: attempts,
                       max_attempts: @review_error_auto_recovery_limit)
       rescue StandardError => e
@@ -586,7 +608,7 @@ module Hive
         reason.to_s
       end
 
-      def auto_recoverable_review_error?(row, now:)
+      def auto_recoverable_review_error?(row, now:, retained_completion_evidence: nil)
         attrs = marker_attrs_for(row)
         return true if attrs["reason"].to_s == "review_agent_died"
 
@@ -613,12 +635,12 @@ module Hive
         return true if attrs["phase"].to_s == "fix" &&
                        FIX_AUTO_COMMIT_RETRYABLE_REASONS.include?(attrs["reason"].to_s)
 
-        # Legacy Claude Code stop-hook failures are environmental: the fix run
-        # completed far enough to hit the stop hook, but the hook failed to
-        # signal completion and Review stamped a generic fix_failed marker.
-        # Keep ordinary fix_failed manual; this bounded retry only covers the
-        # exact known stop-hook signature and still re-runs the normal fix path.
-        return true if fix_claude_stop_hook_failure?(attrs)
+        # Historical Stop-hook failures no longer clear from message text. The
+        # caller admits this branch only after retained fallback audit +
+        # manifest + git evidence prove the same predicate the live Review
+        # runner uses.  Ordinary legacy rows have no independently recorded
+        # exit status and therefore stay red for an operator-guided rerun.
+        return !retained_completion_evidence.nil? if fix_claude_stop_hook_failure?(attrs)
 
         return false unless attrs["phase"].to_s == "reviewers"
         return false unless attrs["reason"].to_s == "reviewer_partial_failure"
@@ -643,6 +665,81 @@ module Hive
           attrs["message"].to_s == FIX_CLAUDE_STOP_HOOK_MESSAGE
       end
 
+      # Recover a historical stop-hook marker only when retained files can
+      # replay the live fallback predicate.  Most legacy rows predate the
+      # retained tmux exit/audit contract, so this intentionally returns a
+      # refusal instead of guessing from the old ensure-closed agent_end.
+      #
+      # Production REVIEW_ERROR stop-hook rows never write fix-success before
+      # parking; a successful heal creates (or retains a still-fresh) sentinel
+      # via the Review-owned helper so the next run advances past the pass.
+      def retained_fix_completion_evidence(row)
+        attrs = marker_attrs_for(row)
+        pass = Integer(attrs["pass"], exception: false)
+        return [ nil, "marker has no valid pass" ] unless pass
+
+        audit = fallback_audit_event(row, pass)
+        return [ nil, "verified fallback audit event with process exit 0 is absent" ] unless audit
+
+        result_path = Hive::Stages::Review::CompletionEvidence.result_path(row.folder, pass)
+        raw = JSON.parse(File.read(result_path))
+        # Bind identity to orchestrator-owned row/marker fields, not the
+        # manifest's self-attested slug/pass. Nonce/baseline/count still come
+        # from the retained file and are cross-checked by evaluate.
+        binding = {
+          path: result_path,
+          slug: row.slug,
+          pass: pass,
+          nonce: raw["nonce"],
+          baseline_head: raw["baseline_head"],
+          accepted_findings: raw["accepted_findings"]
+        }
+        pointer = Hive::Worktree.read_pointer(row.folder)
+        worktree_path = pointer["path"]
+        return [ nil, "worktree is unreadable" ] unless File.directory?(worktree_path)
+
+        ctx = Hive::Stages::Review::Context.new(
+          worktree_path: worktree_path, task_folder: row.folder,
+          default_branch: "recovery", pass: pass
+        )
+        evaluation = Hive::Stages::Review::CompletionEvidence.evaluate(
+          task: nil, ctx: ctx, binding: binding,
+          observation: { process_exit_code: 0 }, worktree_path: worktree_path,
+          wrapper_completion_recorded: true
+        )
+        return [ nil, evaluation.reason ] unless evaluation.accepted
+
+        fix_success = Hive::Stages::Review.fix_success_path(row.folder, pass)
+        escalations = File.join(row.folder, "reviews", "escalations-#{format('%02d', pass)}.md")
+        unless Hive::Stages::Review.fix_success_fresh?(fix_success, escalations)
+          Hive::Stages::Review.write_fix_success(ctx)
+        end
+
+        [ evaluation, nil ]
+      rescue JSON::ParserError, SystemCallError, IOError, KeyError, TypeError => e
+        [ nil, "retained completion evidence is unreadable: #{e.message}" ]
+      end
+
+      def fallback_audit_event(row, pass)
+        path = File.join(row.folder.to_s, "events.jsonl")
+        return nil unless File.file?(path)
+
+        File.foreach(path).filter_map do |line|
+          record = JSON.parse(line)
+          next unless record["event_type"] == "claude_completion_fallback" && record["level"] == "warn"
+
+          metadata = record["metadata"]
+          next unless metadata.is_a?(Hash) && metadata["phase"] == "fix" &&
+                      metadata["pass"].to_i == pass && metadata["process_exit_code"].to_i == 0
+
+          record
+        rescue JSON::ParserError
+          nil
+        end.last
+      rescue SystemCallError, IOError
+        nil
+      end
+
       def reviewer_errors_path(row)
         attrs = marker_attrs_for(row)
         pass = Integer(attrs["pass"], exception: false)
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index 31ecc07a..03a57abe 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -14,7 +14,11 @@ module Hive
       round_waiting
       round_complete
       clean_exit_auto_committed
+      claude_completion_fallback
     ].freeze
+    EVENT_LEVELS = %w[info warn error].freeze
+    MAX_METADATA_VALUE_BYTES = 256
+    MAX_METADATA_ENTRIES = 16
 
     STATUS_TAIL_LINES = 20
     # Width of the trailing window scanned to recover the "current agent"
@@ -45,7 +49,8 @@ module Hive
     # appenders via the inode lock; we cap message size (see
     # MAX_MESSAGE_BYTES) so the full line stays small and well-defined.
     # status.md is derived state and is rewritten with atomic rename.
-    def emit(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil)
+    def emit(task_folder:, slug:, stage:, event_type:, agent: nil, message: nil,
+             level: nil, metadata: nil)
       event_type = event_type.to_sym
       unless EVENT_TYPES.include?(event_type)
         raise ArgumentError, "unknown event_type #{event_type.inspect}; valid: #{EVENT_TYPES.inspect}"
@@ -59,6 +64,14 @@ module Hive
         "event_type" => event_type.to_s,
         "message" => message.nil? ? nil : truncate_message(message.to_s)
       }
+      if level
+        level = level.to_s
+        raise ArgumentError, "unknown event level #{level.inspect}; valid: #{EVENT_LEVELS.inspect}" unless EVENT_LEVELS.include?(level)
+
+        record["level"] = level
+      end
+      normalized_metadata = normalize_metadata(metadata)
+      record["metadata"] = normalized_metadata unless normalized_metadata.empty?
 
       FileUtils.mkdir_p(task_folder)
       events_path = File.join(task_folder, "events.jsonl")
@@ -87,6 +100,33 @@ module Hive
       "#{trimmed}#{MESSAGE_TRUNCATION_SUFFIX}"
     end
 
+    # Metadata is intentionally shallow and bounded.  Audit events should
+    # name evidence paths/ids, never embed reviewer output or pane transcripts.
+    def normalize_metadata(metadata)
+      return {} unless metadata.is_a?(Hash)
+
+      metadata.first(MAX_METADATA_ENTRIES).each_with_object({}) do |(key, value), out|
+        next unless key.to_s.match?(/\A[a-zA-Z0-9_.-]+\z/)
+
+        normalized = case value
+                     when Array
+                       value.first(8).map { |item| truncate_metadata_value(item) }
+                     when Hash
+                       nil
+                     else
+                       truncate_metadata_value(value)
+                     end
+        out[key.to_s] = normalized unless normalized.nil?
+      end
+    end
+
+    def truncate_metadata_value(value)
+      text = value.to_s
+      return text if text.bytesize <= MAX_METADATA_VALUE_BYTES
+
+      text.byteslice(0, MAX_METADATA_VALUE_BYTES).to_s.scrub("")
+    end
+
     def render_status!(task_folder, last_record)
       events_path = File.join(task_folder, "events.jsonl")
       events = read_recent_events(events_path, STATUS_TAIL_LINES)
diff --git a/lib/hive/scripts/stop_hook.sh b/lib/hive/scripts/stop_hook.sh
index 086433f0..1452053b 100755
--- a/lib/hive/scripts/stop_hook.sh
+++ b/lib/hive/scripts/stop_hook.sh
@@ -9,10 +9,21 @@ set -eu
 # data". If stdin is empty, write an explicit sentinel JSON object
 # instead so the operator can tell the difference.
 result_path="${HIVE_TASK_STAGE_DIR}/result.json"
+# Publish result.json atomically before the wake-up sentinel.  The launcher
+# treats `.done` as permission to inspect the result, so a direct redirect
+# could make it observe a half-written payload on a busy filesystem.  Keep
+# the temporary file beside the final path: rename(2) is atomic only within
+# one filesystem.
+tmp_path=$(mktemp "${result_path}.tmp.XXXXXX")
+trap 'rm -f "$tmp_path"' EXIT HUP INT TERM
+
 payload=$(cat)
 if [ -z "$payload" ]; then
-  printf '%s\n' '{"hive_stop_hook":"empty_stdin"}' > "$result_path"
+  printf '%s\n' '{"hive_stop_hook":"empty_stdin"}' > "$tmp_path"
 else
-  printf '%s' "$payload" > "$result_path"
+  printf '%s' "$payload" > "$tmp_path"
 fi
+
+mv -f "$tmp_path" "$result_path"
+trap - EXIT HUP INT TERM
 touch "${HIVE_TASK_STAGE_DIR}/.done"
diff --git a/lib/hive/stages/base.rb b/lib/hive/stages/base.rb
index 979b4800..057b0362 100644
--- a/lib/hive/stages/base.rb
+++ b/lib/hive/stages/base.rb
@@ -562,7 +562,7 @@ module Hive
                          profile: nil, expected_output: nil, status_mode: nil,
                          permission_mode: nil, allowed_tools: nil,
                          disallowed_tools: nil, mcp_config_path: nil,
-                         strict_mcp_config: false)
+                         strict_mcp_config: false, completion_verifier: nil)
         require "hive/claude_launcher"
 
         profile ||= Hive::AgentProfiles.lookup(:claude, cfg: cfg)
@@ -588,7 +588,8 @@ module Hive
           allowed_tools: allowed_tools,
           disallowed_tools: disallowed_tools,
           mcp_config_path: mcp_config_path,
-          strict_mcp_config: strict_mcp_config
+          strict_mcp_config: strict_mcp_config,
+          completion_verifier: completion_verifier
         )
       end
 
